SUBROUTINE DEALLOC_CHECK_TEB(CT)

USE MODD_CHECK_TEB, ONLY : CHECK_TEB_t

USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE

TYPE(CHECK_TEB_t), INTENT(INOUT) :: CT
  
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!-------------------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('ALLOC_CHECK_TEB',0,ZHOOK_HANDLE)
!-------------------------------------------------------------------------------------)
!
  DEALLOCATE(CT%XFLUXFLOOR)          ! Heat flux into the ground floor
  DEALLOCATE(CT%XFLX_BLD_ROOF)       ! Heat exchange between roof and indoor air
  DEALLOCATE(CT%XFLX_BLD_WALL_A)     ! Heat exchange between wall A and indoor air
  DEALLOCATE(CT%XFLX_BLD_WALL_B)     ! Heat exchange between wall B and indoor air
  !
  DEALLOCATE(CT%XHEAT_RR_ROAD)
  DEALLOCATE(CT%XHEAT_RR_ROOF)
  !
  DEALLOCATE(CT%XSEN_SNOW_DIF_ROAD) ! Sensible heat due to snowfall on road
  DEALLOCATE(CT%XSEN_SNOW_DIF_ROOF) ! Sensible heat due to snowfall on roof
  !
  DEALLOCATE(CT%XDIAG_DCS_AREA)
  !
  DEALLOCATE(CT%XSEN_GREENROOF)
  DEALLOCATE(CT%XLAT_GREENROOF)

  DEALLOCATE(CT%XLAT_SOIL_TO_GARDEN)

  DEALLOCATE(CT%XWATER_ROAD)
  DEALLOCATE(CT%XWATER_BLD)
  DEALLOCATE(CT%XWATER_GARDEN)

  DEALLOCATE(CT%XSEN_MELT_ROAD)
  DEALLOCATE(CT%XSEN_MELT_ROOF)
  DEALLOCATE(CT%XDIFF_SNOW_WAT_ROAD)
  DEALLOCATE(CT%XDIFF_SNOW_WAT_ROOF)

  DEALLOCATE(CT%XCONV_LAT_SEN_ROAD)
  DEALLOCATE(CT%XCONV_LAT_SEN_ROOF)
  !
  DEALLOCATE(CT%XDQS_SNOW_ROOF)
  DEALLOCATE(CT%XDQS_SNOW_ROAD)

  DEALLOCATE(CT%XRHOI)

  DEALLOCATE(CT%XRN)
  DEALLOCATE(CT%XH)
  DEALLOCATE(CT%XLE)

  DEALLOCATE(CT%XLW_WALA_TO_ROAD)
  DEALLOCATE(CT%XLW_WALB_TO_ROAD)
  DEALLOCATE(CT%XLW_WIND_TO_ROAD)
  DEALLOCATE(CT%XLW_WALA_TO_GARD)
  DEALLOCATE(CT%XLW_WALB_TO_GARD)
  DEALLOCATE(CT%XLW_WIND_TO_GARD)
  DEALLOCATE(CT%XLW_ROAD_TO_WIND)
  DEALLOCATE(CT%XLW_WALL_TO_WIND)
  DEALLOCATE(CT%XLW_SNOW_TO_WIND)
  DEALLOCATE(CT%XLW_GARD_TO_WIND)
  DEALLOCATE(CT%XLW_ROAD_TO_WALA)
  DEALLOCATE(CT%XLW_GARD_TO_WALA)
  DEALLOCATE(CT%XLW_SNOW_TO_WALA)
  DEALLOCATE(CT%XLW_WALB_TO_WALA)
  DEALLOCATE(CT%XLW_WIND_TO_WALA)
  DEALLOCATE(CT%XLW_ROAD_TO_WALB)
  DEALLOCATE(CT%XLW_GARD_TO_WALB)
  DEALLOCATE(CT%XLW_SNOW_TO_WALB)
  DEALLOCATE(CT%XLW_WALA_TO_WALB)
  DEALLOCATE(CT%XLW_WIND_TO_WALB)
  DEALLOCATE(CT%XLW_WALA_TO_SNOW)
  DEALLOCATE(CT%XLW_WALB_TO_SNOW)
  DEALLOCATE(CT%XLW_WIND_TO_SNOW)
  DEALLOCATE(CT%XLW_ROAD_TO_HV)
  DEALLOCATE(CT%XLW_WALA_TO_HV)
  DEALLOCATE(CT%XLW_WALB_TO_HV)
  DEALLOCATE(CT%XLW_WIND_TO_HV)
  DEALLOCATE(CT%XLW_GARD_TO_HV)
  DEALLOCATE(CT%XLW_SNOW_TO_HV)
  DEALLOCATE(CT%XLW_HV_TO_ROAD)
  DEALLOCATE(CT%XLW_HV_TO_WALA)
  DEALLOCATE(CT%XLW_HV_TO_WALB)
  DEALLOCATE(CT%XLW_HV_TO_WIND)
  DEALLOCATE(CT%XLW_HV_TO_GARD)
  DEALLOCATE(CT%XLW_HV_TO_SNOW)

IF (LHOOK) CALL DR_HOOK('DEALLOC_CHECK_TEB',1,ZHOOK_HANDLE)

END SUBROUTINE
